## xnbd 0.0.3+hg20110222

=== Makefile ===
#  xNBD - an enhanced Network Block Device program
# 
#  Copyright (C) 2008-2011 National Institute of Advanced Industrial Science
#  and Technology
# 
#  Author: Takahiro Hirofuchi <t.hirofuchi _at_ aist.go.jp>
# 
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2 of the License, or (at your option)
#  any later version.
# 
#  This program is distributed in the hope that it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#  more details.
# 
#  You should have received a copy of the GNU General Public License along with
#  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
#  Place - Suite 330, Boston, MA 02111-1307, USA.


CC=gcc
INSTALL=install
MAKE=make
RM=rm

# -O3 $(MAKE)s a broken binary.
# CFLAGS_COMMON=-g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2
CFLAGS_COMMON=-g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0`
#CFLAGS_COMMON=-g -O2 -Wall -Wextra -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2 -DXNBD_LZO
#CFLAGS_COMMON=-g -O2 -ftrapv -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2
XUTILSPATH=./lib
CFLAGS=$(CFLAGS_COMMON) -I$(XUTILSPATH) -L$(XUTILSPATH) -lxutils
CFLAGS_DEBUG=$(CFLAGS_COMMON) -I$(XUTILSPATH) -L$(XUTILSPATH) -lxutils_dbg -DXNBD_DEBUG

#CFLAGS_CHECKING=-O2 -Wall -fstack-protector -fstack-check -fmudflapth -lmudflapth -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` 
#CFLAGS_CHECKING=-O2 -Wall -Wextra -std=gnu99 -fmudflapth -lmudflapth  `pkg-config --cflags --libs glib-2.0 gthread-2.0` 
#CFLAGS_CHECKING=-O2 -Wall -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` 

#CFLAGS=-g3 -fstack-protector -fmudflapth -lmudflapth -Wall -Wextra -std=gnu99

SRC=xnbd.c xnbd_common.c xnbd_cachestat.c xnbd_proxy.c xnbd_target.c xnbd_target_cow_lzo.c
OBJ=$(SRC:%.c=%.o)

xnbdobj_dbg=$(patsubst %.c, %___dbg.o, $(SRC))


%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

%___dbg.o: %.c
	$(CC) $(CFLAGS_DEBUG) -c $< -o $@

%.d: %.c
	$(CC) -MM $(CFLAGS) $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@

%__dbg.d: %.c
	$(CC) -MM $(CFLAGS_DEBUG) $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@


default: xnbd-server xnbd-bgctl xnbd-client xnbd-watchdog

# 1. Put $(OBJ) before $(CFLAGS). To avoid undefined reference error, object
# files must be followed by static libraries to be linked with them.
#
# 2. Do $(MAKE) -C $(XUTILSPATH). This makes sure static libraries are always
# up-to-date for their source files. The dependency files created by gcc -MM do
# not cover the dependency related to *.c of libraries; only cover header
# files.
xnbd-server: $(OBJ)
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-server 

xnbd-server-debug: $(xnbdobj_dbg)
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS_DEBUG) -o xnbd-server-debug

xnbd-server-test: xnbd_proxy.c $(filter-out xnbd_proxy.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -DXNBD_STATIC_BGCTLPATH -o xnbd-server-test

xnbd-server-cachestat: $(OBJ)
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -DCACHESTAT_ENABLED -o xnbd-server-cachestat

xnbd-cachestatdump: xnbd_cachestatdump.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-cachestatdump

xnbd-tester: xnbd_tester.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-tester

xnbd-tester2: xnbd_tester2.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-tester2

xnbd-bgctl: xnbd_bgctl.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-bgctl

xnbd-client: xnbd_client.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-client

xnbd-watchdog: xnbd_watchdog.c $(filter-out xnbd.o, $(OBJ))
	$(MAKE) -C $(XUTILSPATH)
	$(CC) $^ $(CFLAGS) -o xnbd-watchdog

.PHONY: manpages
manpages:
	$(MAKE) -C doc

#$(XUTILSPATH)/libxutils.a: $(wildcard $(XUTILSPATH)/*.c)
#	$(MAKE) -C $(XUTILSPATH) libxutils.a
#
#$(XUTILSPATH)/libxutils_dbg.a:
#	$(MAKE) -C $(XUTILSPATH) libxutils_dbg.a


.PHONY: clean install
clean:
	$(MAKE) -C $(XUTILSPATH) clean
	$(MAKE) -C doc clean
	$(RM) -rf *.o *.d xnbd-server xnbd-server-debug xnbd-server-test xnbd-server-cachestat xnbd-cachestatdump xnbd-bgctl xnbd-tester xnbd-client xnbd-watchdog

install: default
	$(INSTALL) -D --mode=0755 xnbd-server $(DESTDIR)/usr/sbin/xnbd-server
	$(INSTALL) -D --mode=0755 xnbd-bgctl  $(DESTDIR)/usr/sbin/xnbd-bgctl
	$(INSTALL) -D --mode=0755 xnbd-client  $(DESTDIR)/usr/bin/xnbd-client
	$(INSTALL) -D --mode=0755 xnbd-watchdog $(DESTDIR)/usr/bin/xnbd-watchdog


-include $(patsubst %.c, %.d, $(SRC))

=== doc/Makefile ===
default: xnbd-client.1.sgml xnbd-server.8.sgml xnbd-bgctl.1.sgml xnbd-watchdog.1.sgml
	docbook-to-man xnbd-client.1.sgml > xnbd-client.1
	docbook-to-man xnbd-server.8.sgml > xnbd-server.8
	docbook-to-man xnbd-bgctl.1.sgml > xnbd-bgctl.1
	docbook-to-man xnbd-watchdog.1.sgml > xnbd-watchdog.1
clean:
	$(RM) -rf xnbd-client.1 xnbd-server.8 xnbd-bgctl.1 xnbd-watchdog.1

=== lib/Makefile ===
# 
# xNBD - an enhanced Network Block Device program
# 
# Copyright (C) 2008-2011 National Institute of Advanced Industrial Science
# and Technology
# 
# Author: Takahiro Hirofuchi <t.hirofuchi _at_ aist.go.jp>
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.




CC=gcc
CFLAGS=-g -O2 -Wall -fstack-protector -fstack-check -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` 
SRC=common.c net.c io.c bitmap.c nbd.c
OBJ=$(SRC:%.c=%.o)

obj_dbg=$(patsubst %.c, %___dbg.o, $(SRC))


%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

%___dbg.o: %.c
	$(CC) $(CFLAGS) -DXNBD_DEBUG -c $< -o $@

%.d: %.c
	$(CC) -MM $(CFLAGS) $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@

all: libxutils.a libxutils_dbg.a

libxutils.a: $(OBJ)
	ar crsv $@ $^

libxutils_dbg.a: $(obj_dbg)
	ar crsv $@ $^

.PHONY: all clean 
clean:
	rm -rf *.o *.d *.a

-include $(patsubst %.c, %.d, $(SRC))

=== debian/changelog ===
xnbd (0.0.3+hg20110222-1) unstable; urgency=low

  * New upstream release
  * Adapt to changes as upstream now incorporates several
    Debian improvements (man pages, Makefile).
  * Fixes license issue with upstream code

 -- Arno Töll <debian@toell.net>  Tue, 03 May 2011 18:39:29 +0200

xnbd (0.0.3+hg20110210-1) unstable; urgency=low

  * Initial release (Closes: #612817)  

 -- Arno Töll <debian@toell.net>  Thu, 10 Feb 2011 15:32:57 -0500

=== debian/control ===
Source: xnbd
Section: admin
Priority: extra
Maintainer: Arno Töll <debian@toell.net>
Build-Depends: debhelper (>= 8.0), libglib2.0-dev, docbook-to-man
Standards-Version: 3.9.2
Homepage: https://bitbucket.org/hirofuchi/xnbd/wiki/Home
Vcs-Svn: svn://scm.alioth.debian.org/svn/collab-maint/ext-maint/xnbd/trunk
Vcs-Browser: https://alioth.debian.org/scm/viewvc.php/ext-maint/xnbd/trunk?root=collab-maint

Package: xnbd-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Network Block Device server with support for live migration
 xNBD is a NBD (Network Block Device) server program, which is fully compatible 
 with the NBD client driver of Linux kernel. It adds extended features to the 
 traditional NBD server:
 .
  * Better performance
  * Support for distributed copy-on-write disks
  * Live storage migration for virtual machines.
  * IPv6 support. 
 .
 This is the server side of the program
 


Package: xnbd-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Network Block Device client with support for live migration
 xNBD is a NBD (Network Block Device) server program, which is fully compatible 
 with the NBD client driver of Linux kernel. It adds extended features to the 
 traditional NBD server:
 .
  * Better performance
  * Support for distributed copy-on-write disks
  * Live storage migration for virtual machines.
  * IPv6 support. 
 .
 This is the client side of the program

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh $@ 

override_dh_install:
	dh_install --fail-missing

override_dh_auto_build:
	docbook-to-man doc/xnbd-client.1.sgml > debian/xnbd-client.1
	docbook-to-man doc/xnbd-server.8.sgml > debian/xnbd-server.8
	docbook-to-man doc/xnbd-bgctl.1.sgml > debian/xnbd-bgctl.1
	docbook-to-man doc/xnbd-watchdog.1.sgml > debian/xnbd-watchdog.1
	dh_auto_build

override_dh_clean:
	dh_clean
	rm -f debian/xnbd-client.1 debian/xnbd-server.8 debian/xnbd-bgctl.1 debian/xnbd-watchdog.1

## xnbd 0.1.0

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,11 @@
 
 # -O3 $(MAKE)s a broken binary.
 # CFLAGS_COMMON=-g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2
+
 CFLAGS_COMMON=-g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0`
+CFLAGS_COMMON=-g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0`
+
+
 #CFLAGS_COMMON=-g -O2 -Wall -Wextra -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2 -DXNBD_LZO
 #CFLAGS_COMMON=-g -O2 -ftrapv -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -Wconversion -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -llzo2
 XUTILSPATH=./lib
@@ -40,10 +44,10 @@
 
 #CFLAGS=-g3 -fstack-protector -fmudflapth -lmudflapth -Wall -Wextra -std=gnu99
 
-SRC=xnbd.c xnbd_common.c xnbd_cachestat.c xnbd_proxy.c xnbd_target.c xnbd_target_cow_lzo.c
+SRC=xnbd.c xnbd_common.c xnbd_cachestat.c xnbd_proxy.c xnbd_proxy_forwarder.c xnbd_target.c xnbd_target_cow_lzo.c
 OBJ=$(SRC:%.c=%.o)
 
-xnbdobj_dbg=$(patsubst %.c, %___dbg.o, $(SRC))
+OBJ_DBG=$(patsubst %.c, %___dbg.o, $(SRC))
 
 
 %.o: %.c
@@ -59,7 +63,7 @@
 	$(CC) -MM $(CFLAGS_DEBUG) $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@
 
 
-default: xnbd-server xnbd-bgctl xnbd-client xnbd-watchdog
+default: xnbd-server xnbd-bgctl xnbd-client xnbd-watchdog xnbd-wrapper
 
 # 1. Put $(OBJ) before $(CFLAGS). To avoid undefined reference error, object
 # files must be followed by static libraries to be linked with them.
@@ -72,13 +76,9 @@
 	$(MAKE) -C $(XUTILSPATH)
 	$(CC) $^ $(CFLAGS) -o xnbd-server 
 
-xnbd-server-debug: $(xnbdobj_dbg)
+xnbd-server-debug: $(OBJ_DBG)
 	$(MAKE) -C $(XUTILSPATH)
 	$(CC) $^ $(CFLAGS_DEBUG) -o xnbd-server-debug
-
-xnbd-server-test: xnbd_proxy.c $(filter-out xnbd_proxy.o, $(OBJ))
-	$(MAKE) -C $(XUTILSPATH)
-	$(CC) $^ $(CFLAGS) -DXNBD_STATIC_BGCTLPATH -o xnbd-server-test
 
 xnbd-server-cachestat: $(OBJ)
 	$(MAKE) -C $(XUTILSPATH)
@@ -100,6 +100,10 @@
 	$(MAKE) -C $(XUTILSPATH)
 	$(CC) $^ $(CFLAGS) -o xnbd-bgctl
 
+xnbd-bgctl-debug: xnbd_bgctl.c $(filter-out xnbd___dbg.o, $(OBJ_DBG))
+	$(MAKE) -C $(XUTILSPATH)
+	$(CC) $^ $(CFLAGS_DEBUG) -o xnbd-bgctl-debug
+
 xnbd-client: xnbd_client.c $(filter-out xnbd.o, $(OBJ))
 	$(MAKE) -C $(XUTILSPATH)
 	$(CC) $^ $(CFLAGS) -o xnbd-client
@@ -107,6 +111,10 @@
 xnbd-watchdog: xnbd_watchdog.c $(filter-out xnbd.o, $(OBJ))
 	$(MAKE) -C $(XUTILSPATH)
 	$(CC) $^ $(CFLAGS) -o xnbd-watchdog
+
+xnbd-wrapper: xnbd_wrapper.c $(filter-out xnbd.o, $(OBJ))
+	$(MAKE) -C $(XUTILSPATH)
+	$(CC) $^ $(CFLAGS) -o xnbd-wrapper
 
 .PHONY: manpages
 manpages:
@@ -123,11 +131,13 @@
 clean:
 	$(MAKE) -C $(XUTILSPATH) clean
 	$(MAKE) -C doc clean
-	$(RM) -rf *.o *.d xnbd-server xnbd-server-debug xnbd-server-test xnbd-server-cachestat xnbd-cachestatdump xnbd-bgctl xnbd-tester xnbd-client xnbd-watchdog
+	$(RM) -rf *.o *.d xnbd-server xnbd-server-debug xnbd-server-test xnbd-server-cachestat xnbd-cachestatdump xnbd-bgctl xnbd-tester xnbd-client xnbd-watchdog xnbd-wrapper
 
 install: default
 	$(INSTALL) -D --mode=0755 xnbd-server $(DESTDIR)/usr/sbin/xnbd-server
 	$(INSTALL) -D --mode=0755 xnbd-bgctl  $(DESTDIR)/usr/sbin/xnbd-bgctl
+	$(INSTALL) -D --mode=0755 xnbd-wrapper  $(DESTDIR)/usr/sbin/xnbd-wrapper
+	$(INSTALL) -D --mode=0755 xnbd-wrapper-ctl.py  $(DESTDIR)/usr/sbin/xnbd-wrapper-ctl
 	$(INSTALL) -D --mode=0755 xnbd-client  $(DESTDIR)/usr/bin/xnbd-client
 	$(INSTALL) -D --mode=0755 xnbd-watchdog $(DESTDIR)/usr/bin/xnbd-watchdog

=== doc/Makefile ===
default: xnbd-client.1.sgml xnbd-server.8.sgml xnbd-bgctl.1.sgml xnbd-watchdog.1.sgml xnbd-wrapper-ctl.8.sgml xnbd-wrapper.8.sgml
	docbook-to-man xnbd-client.1.sgml > xnbd-client.1
	docbook-to-man xnbd-server.8.sgml > xnbd-server.8
	docbook-to-man xnbd-bgctl.1.sgml > xnbd-bgctl.1
	docbook-to-man xnbd-watchdog.1.sgml > xnbd-watchdog.1
	docbook-to-man xnbd-wrapper.8.sgml > xnbd-wrapper.8
	docbook-to-man xnbd-wrapper-ctl.8.sgml > xnbd-wrapper-ctl.8

clean:
	$(RM) -rf xnbd-client.1 xnbd-server.8 xnbd-bgctl.1 xnbd-watchdog.1 xnbd-wrapper-ctl.8 xnbd-wrapper.8

## xnbd 0.1.0-pre+hg20110702

=== debian/changelog ===
xnbd (0.1.0-pre+hg20110702-1) unstable; urgency=low

  [ Arno Töll ]
  * New upstream release.
  * Update `README.Debian' to reflect the most recent status
  * Ship `xnbd-register' a Debian helper to restore xNBD devices at boot. This
    is a Debian specific improvement which is driven by a configuration file
    located in `/etc/xnbd.conf'.
  * Add `wrapper-daemonize.patch' which enables to run the `xnbd-wrapper'
    command in the background and to shutdown upon request.
  * Add `xnbd-common' package which contains startup wrapper for both,
    `xnbd-client' and `xnbd-server'.
  * Add patch `fix-xnbd-path' to reflect better the Debian installation layout.
  * Build depend on Python helpers.
  
  [ Sven Höxter ]
  * Add DM-Upload-Allowed: yes.

 -- Arno Töll <debian@toell.net>  Tue, 19 Jul 2011 21:09:03 +0200

=== debian/control ===
Source: xnbd
Section: admin
Priority: extra
Maintainer: Arno Töll <debian@toell.net>
Build-Depends: debhelper (>= 8.0),
 libglib2.0-dev,
 docbook-to-man,
 python-all-dev (>= 2.6.6-3~)
Standards-Version: 3.9.2
Homepage: https://bitbucket.org/hirofuchi/xnbd/wiki/Home
Vcs-Svn: svn://scm.alioth.debian.org/svn/collab-maint/ext-maint/xnbd/trunk
Vcs-Browser: https://alioth.debian.org/scm/viewvc.php/ext-maint/xnbd/trunk?root=collab-maint
DM-Upload-Allowed: yes

Package: xnbd-server
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 xnbd-common (= ${source:Version})
Description: Network Block Device server with support for live migration
 xNBD is a NBD (Network Block Device) server program, which is fully compatible
 with the NBD client driver of Linux kernel. It adds extended features to the
 traditional NBD server:
 .
  * Better performance
  * Support for distributed copy-on-write disks
  * Live storage migration for virtual machines.
  * IPv6 support.
 .
 This is the server side of the program



Package: xnbd-client
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 xnbd-common (= ${source:Version})
Description: Network Block Device client with support for live migration
 xNBD is a NBD (Network Block Device) server program, which is fully compatible
 with the NBD client driver of Linux kernel. It adds extended features to the
 traditional NBD server:
 .
  * Better performance
  * Support for distributed copy-on-write disks
  * Live storage migration for virtual machines.
  * IPv6 support.
 .
 This is the client side of the program


Package: xnbd-common
Architecture: all
Depends: ${misc:Depends},
 lsb-base (>= 3.2-14),
 python-argparse,
 ${python:Depends}
Description: Network Block Device - common files
 xNBD is a NBD (Network Block Device) server program, which is fully compatible
 with the NBD client driver of Linux kernel. It adds extended features to the
 traditional NBD server.
 .
 This package contains common files and shared directories.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@ --with python2

override_dh_install:
	dh_install --fail-missing

override_dh_auto_build:
	docbook-to-man doc/xnbd-client.1.sgml > debian/xnbd-client.1
	docbook-to-man doc/xnbd-server.8.sgml > debian/xnbd-server.8
	docbook-to-man doc/xnbd-bgctl.1.sgml > debian/xnbd-bgctl.1
	docbook-to-man doc/xnbd-watchdog.1.sgml > debian/xnbd-watchdog.1
	docbook-to-man doc/xnbd-wrapper.8.sgml > debian/xnbd-wrapper.8
	docbook-to-man doc/xnbd-wrapper-ctl.8.sgml > debian/xnbd-wrapper-ctl.8
	# xnbd-register is a Debian improvement
	docbook-to-man debian/xnbd-register.8.sgml > debian/xnbd-register.8
	dh_auto_build

override_dh_clean:
	dh_clean
	rm -f debian/xnbd-client.1 debian/xnbd-server.8 debian/xnbd-bgctl.1 \
		debian/xnbd-watchdog.1 debian/xnbd-wrapper.8 debian/xnbd-wrapper-ctl.8

override_dh_installinit:
	# don't start upon installation/upgrade. We can't ship a feasible
	# default configuration.
	dh_installinit --no-start

## xnbd 0.1.0-pre-hg17

=== trunk/Makefile ===
#  xNBD - an enhanced Network Block Device program
# 
#  Copyright (C) 2008-2011 National Institute of Advanced Industrial Science
#  and Technology
# 
#  Author: Takahiro Hirofuchi <t.hirofuchi _at_ aist.go.jp>
# 
#  This program is free software; you can redistribute it and/or modify it
#  under the terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 2 of the License, or (at your option)
#  any later version.
# 
#  This program is distributed in the hope that it will be useful, but WITHOUT
#  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#  more details.
# 
#  You should have received a copy of the GNU General Public License along with
#  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
#  Place - Suite 330, Boston, MA 02111-1307, USA.


INSTALL = install
PREFIX ?= $(DESTDIR)/usr/sbin


DOCPATH = ./doc
XUTILSPATH = ./lib

# -O3 $(MAKE)s a broken binary.
COMMON_BUILD_FLAGS	:= -g -O2 -Wall -Wextra -Wstrict-aliasing=2 -Wformat=2 -Wcast-align -Wwrite-strings -Wfloat-equal -Wpointer-arith -Wswitch-enum -fstack-protector -fstack-check -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0` -I$(XUTILSPATH) -L$(XUTILSPATH)
DEFAULT_BUILD_FLAGS	:= $(COMMON_BUILD_FLAGS) -lxutils
# -DCACHESTAT_ENABLED does not work.
DEBUG_BUILD_FLAGS	:= $(COMMON_BUILD_FLAGS) -lxutils_dbg -DXNBD_DEBUG

SRC			:= $(wildcard *.c)
# xnbd-cachestatdump is out-of-date.
BINARIES 		:= xnbd-server xnbd-bgctl xnbd-client xnbd-watchdog xnbd-wrapper xnbd-cachestatdump xnbd-tester
BINARIES_OBJ		:= $(subst -,_,$(BINARIES:%=%.o))
OBJ			:= $(SRC:%.c=%.o)

BINARIES_DBG		:= $(BINARIES:%=%-debug)
BINARIES_OBJ_DBG	:= $(BINARIES_OBJ:%.o=%___dbg.o)
OBJ_DBG			:= $(patsubst %.c, %___dbg.o, $(SRC))

.PHONY: all
all: default

%.o: %.c
	$(COMPILE.c) $(DEFAULT_BUILD_FLAGS) -c $< -o $@

%___dbg.o: %.c
	$(COMPILE.c) $(DEBUG_BUILD_FLAGS) -c $< -o $@

%.d: %.c
	$(COMPILE.c) -MM $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@

%__dbg.d: %.c
	$(COMPILE.c) -MM $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@


$(XUTILSPATH)/libxutils_dbg.a:
	$(MAKE_COMMAND) -C $(XUTILSPATH) libxutils_dbg.a

$(XUTILSPATH)/libxutils.a:
	$(MAKE_COMMAND) -C $(XUTILSPATH) libxutils.a


$(BINARIES): $(OBJ) $(XUTILSPATH)/libxutils.a
	$(LINK.c) $(subst -,_,$@).o $(filter-out $(BINARIES_OBJ), $^) $(DEFAULT_BUILD_FLAGS) -o $@


$(BINARIES_DBG): $(OBJ_DBG) $(XUTILSPATH)/libxutils_dbg.a
	$(LINK.c) $(subst -,_,$(subst -debug,___dbg,$@).o) $(filter-out	$(BINARIES_OBJ_DBG), $^) $(DEBUG_BUILD_FLAGS) -o $@


.PHONY: default
default: $(BINARIES) manpages

.PHONY: debug
debug: $(BINARIES_DBG)

.PHONY: manpages
manpages:
	$(MAKE_COMMAND) -C $(DOCPATH)

.PHONY: clean install
clean:
	$(MAKE_COMMAND) -C $(XUTILSPATH) clean
	$(MAKE) -C $(DOCPATH) clean
	$(RM) -r *.o *.d $(BINARIES) $(BINARIES_DBG)


install: default
	set -e
	for file in $(filter-out xnbd-cachestatdump xnbd-tester, $(BINARIES)) ; \
	do \
		$(INSTALL) -D --mode=0755 $$file "$(PREFIX)/$$file" ; \
	done

-include $(patsubst %.c, %.d, $(SRC))

=== trunk/doc/Makefile ===
INSTALL ?= install
GZIP 	?= gzip
PREFIX  = $(DESTDIR)/usr/share/

MANPAGES := $(patsubst %.sgml, %.gz, $(wildcard *.sgml))

.PHONY: all
all: $(MANPAGES)

.PHONY: clean
clean:
	$(RM) $(MANPAGES)

.PHONY: install
install:

$(MANPAGES):
	docbook-to-man $(patsubst %.gz, %.sgml, $@) | $(GZIP) > $@

=== trunk/lib/Makefile ===
# 
# xNBD - an enhanced Network Block Device program
# 
# Copyright (C) 2008-2011 National Institute of Advanced Industrial Science
# and Technology
# 
# Author: Takahiro Hirofuchi <t.hirofuchi _at_ aist.go.jp>
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
# 
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.



COMMON_BUILD_FLAGS	?=  -g -O2 -Wall -fstack-protector -fstack-check -Wextra -std=gnu99 `pkg-config --cflags --libs glib-2.0 gthread-2.0`
DEFAULT_BUILD_FLAGS	= $(COMMON_BUILD_FLAGS)
DEBUG_BUILD_FLAGS	= $(COMMON_BUILD_FLAGS)
SRC			:= $(wildcard *.c)
OBJ			:= $(SRC:%.c=%.o)
OBJ_DBG			:= $(patsubst %.c, %___dbg.o, $(SRC))


all: libxutils.a libxutils_dbg.a

%.o: %.c
	$(COMPILE.c) $(DEFAULT_BUILD_FLAGS) -c $< -o $@

%___dbg.o: %.c
	$(COMPILE.c) $(DEBUG_BUILD_FLAGS) -DXNBD_DEBUG -c $< -o $@

%.d: %.c
	$(COMPILE.c) $(DEFAULT_BUILD_FLAGS) -MM $< -MQ $@ -MQ $(patsubst %.d, %.o, $@) -MF $@

libxutils.a: $(OBJ)
	$(AR) crsv $@ $^

libxutils_dbg.a: $(OBJ_DBG)
	$(AR) crsv $@ $^

.PHONY: all clean
clean:
	rm -rf *.o *.d *.a libxutils.a libxutils_dbg.a

-include $(patsubst %.c, %.d, $(SRC))

## xnbd 0.1.0-pre-hg17-c29967ffe2f3

=== debian/changelog ===
xnbd (0.1.0-pre-hg17-c29967ffe2f3-1) unstable; urgency=low

  * New upstream release
  * Remove debian/xnbd-register.8 upon clean
  * Switch to new versioning scheme based on hg versions. This versioning
    scheme can be mapped automatically from a Debian version to a given
    upstream snapshot. Hence a get-orig-source target is provided now which
    can be used to retrieve orig.tar.bz2 tarballs.
  * Remove `wrapper-daemonize.patch': Merged upstream
  * Make package ready for dpkg 1.16.1 and inject build flags into the build
    process. This means, xnbd is now being built with -fstack-protector and
    other security related build flags. To achieve this, the Makefile has
    been rewritten and successively been merged upstream.
  * Add patch `install-xnbd-wrapper-ctl' which makes sure the upstream control
    helper is being installed.
  * Fix some smaller syntax error in the DEP-5 copyright file.
  * Fix a bug in xnbd-register to make sure the server instance is started
    first. This allows one to run both, server and client on the same machine,
    being started from the same configuration file.
  * Add `module-init-tools' to runtime dependencies to make sure, the command is
    available.

 -- Arno Töll <debian@toell.net>  Tue, 25 Oct 2011 00:57:12 +0200

=== debian/control ===
--- 
+++ 
@@ -33,7 +33,7 @@
 
 
 Package: xnbd-client
-Architecture: any
+Architecture: linux-any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  xnbd-common (= ${source:Version})
@@ -54,7 +54,8 @@
 Architecture: all
 Depends: ${misc:Depends},
  lsb-base (>= 3.2-14),
- python-argparse,
+ python (>= 2.7) | python-argparse,
+ module-init-tools,
  ${python:Depends}
 Description: Network Block Device - common files
  xNBD is a NBD (Network Block Device) server program, which is fully compatible

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

VERSION := $(shell dpkg-parsechangelog | perl -ne 'print $$1 if m/Version:\s*([\w\.\-\+]+)-\d+/')
REPOSITORY_REV := $(shell echo "$(VERSION)" | perl -ne 'print $$1 if m/hg\d+-(\w+)/')
CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
export CFLAGS LDFLAGS



%:
	dh $@ --with python2

override_dh_install:
	dh_install --fail-missing

override_dh_auto_build:
	# xnbd-register is a Debian improvement
	docbook-to-man debian/xnbd-register.8.sgml > debian/xnbd-register.8
	make -C trunk

override_dh_auto_clean:
	make -C trunk clean

override_dh_auto_install:
	make -C trunk install DESTDIR=../debian/tmp

override_dh_installinit:
	# don't start upon installation/upgrade. We can't ship a feasible
	# default configuration.
	dh_installinit --no-start


get-orig-source:
	# Version generated by: hg log -r . --template '{latesttag}-hg{latesttagdistance}-{node|short}\n'
	set -e
	hg clone https://bitbucket.org/hirofuchi/xnbd xnbd-$(VERSION)
	cd xnbd-$(VERSION) && hg archive -X .hg_archival.txt -X .hgtags -r $(REPOSITORY_REV) -t tbz2 ../xnbd_$(VERSION).orig.tar.bz2
	rm -rf xnbd-$(VERSION)

## xnbd 0.1.0-pre-hg20

=== trunk/Makefile ===
--- 
+++ 
@@ -97,5 +97,6 @@
 	do \
 		$(INSTALL) -D --mode=0755 $$file "$(PREFIX)/$$file" ; \
 	done
+	$(INSTALL) -D --mode=0755 xnbd-wrapper-ctl.py "$(PREFIX)/xnbd-wrapper-ctl"
 
 -include $(patsubst %.c, %.d, $(SRC))

## xnbd 0.1.0-pre-hg20-e75b93a47722

=== debian/changelog ===
xnbd (0.1.0-pre-hg20-e75b93a47722-3) unstable; urgency=medium

  * Fix "Documentation Error: Option --blocksize mistyped" use correct
    spelling(Closes: #691842)
  * CVE-2013-0265: Fix symlink vulnerability spotted by Sebastian Pipping
    <spipping@wavecon.de>. Moreover, thanks Sebastian for providing a patch.

 -- Arno Töll <arno@debian.org>  Thu, 07 Feb 2013 22:45:10 +0100

xnbd (0.1.0-pre-hg20-e75b93a47722-2) unstable; urgency=low

  * Do a full source rebuild again, now that #670557 is fixed.

 -- Arno Töll <arno@debian.org>  Mon, 28 May 2012 19:16:30 +0200

xnbd (0.1.0-pre-hg20-e75b93a47722-1) unstable; urgency=low

  * New upstream snapshot
  * Refresh patches, drop install-xnbd-wrapper-ctl which was applied upstream.
  * Update my maintainer address and remove "DM-Upload-Allowed: Yes". I don't
    need that anymore.
  * Push standards version to 3.9.3 without further changes.
  * Fix "fails to start, claiming "glib thread not supported"" by adding a
    patch which drops obsolete macro calls which are triggered by the glib 2.32
    transition (Closes: #670521)
  * Temporarily do NOT rebuild manpages from source because of #670557.

 -- Arno Töll <arno@debian.org>  Thu, 26 Apr 2012 19:49:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: xnbd
 Section: admin
 Priority: extra
-Maintainer: Arno Töll <debian@toell.net>
+Maintainer: Arno Töll <arno@debian.org>
 Build-Depends: debhelper (>= 8.0),
  libglib2.0-dev,
  docbook-to-man,
  python-all-dev (>= 2.6.6-3~)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: https://bitbucket.org/hirofuchi/xnbd/wiki/Home
 Vcs-Svn: svn://scm.alioth.debian.org/svn/collab-maint/ext-maint/xnbd/trunk
 Vcs-Browser: https://alioth.debian.org/scm/viewvc.php/ext-maint/xnbd/trunk?root=collab-maint
-DM-Upload-Allowed: yes
 
 Package: xnbd-server
 Architecture: any

## xnbd 0.2.0~rc2-hg1-abf8cc7a1ab0

=== debian/changelog ===
xnbd (0.2.0~rc2-hg1-abf8cc7a1ab0-2) unstable; urgency=low

  * Fix "xnbd-common init script dies during start-up" and use the correct
    path. xndb-register was promoted to the upstream codebase and they decided
    to install it to /usr/sbin. Thus, the init script needs an adaption (Closes: #723559)

 -- Arno Töll <arno@debian.org>  Wed, 18 Sep 2013 11:38:57 +0200

xnbd (0.2.0~rc2-hg1-abf8cc7a1ab0-1) unstable; urgency=low

  * New upstream release
  * Refresh patches:
    - Drop patch fix-670521: Merged upstream
    - Drop patch fix-xnbd-path: The path is deprecated upstream and does not
      work anymore that way
    - Drop patch pelling-fix.patch: applied upstream
    - Drop CVE-2013-0265.patch: Obsoleted by new upstream release
  * Add build-depends to dh-autoreconf, upstream uses autotools now, but we
    build from hg trunk.
  * Remove xnbd-register from the Debian specific additions. It is included
    upstream now.
  * Convert xnbd-common to an architecture specific package, as we ship
    private libraries in it now.
  * Switch build-dependency from docbook to asciidoc. Upstream uses asciidoc
    now.
  * Push standards without additional changes.

 -- Arno Töll <arno@debian.org>  Sat, 08 Jun 2013 11:36:56 +0200

=== debian/control ===
--- 
+++ 
@@ -4,19 +4,24 @@
 Maintainer: Arno Töll <arno@debian.org>
 Build-Depends: debhelper (>= 8.0),
  libglib2.0-dev,
- docbook-to-man,
- python-all-dev (>= 2.6.6-3~)
-Standards-Version: 3.9.3
+ asciidoc,
+ libxml2-utils,
+ docbook-xml,
+ docbook-xsl,
+ xsltproc,
+ python-all-dev (>= 2.6.6-3~),
+ dh-autoreconf
+Standards-Version: 3.9.4
 Homepage: https://bitbucket.org/hirofuchi/xnbd/wiki/Home
-Vcs-Svn: svn://scm.alioth.debian.org/svn/collab-maint/ext-maint/xnbd/trunk
-Vcs-Browser: https://alioth.debian.org/scm/viewvc.php/ext-maint/xnbd/trunk?root=collab-maint
+Vcs-Git: git://anonscm.debian.org/collab-maint/xnbd.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xnbd.git
 
 Package: xnbd-server
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
  ${python:Depends},
- xnbd-common (= ${source:Version})
+ xnbd-common (= ${binary:Version})
 Description: Network Block Device server with support for live migration
  xNBD is a NBD (Network Block Device) server program, which is fully compatible
  with the NBD client driver of Linux kernel. It adds extended features to the
@@ -30,12 +35,11 @@
  This is the server side of the program
 
 
-
 Package: xnbd-client
 Architecture: linux-any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- xnbd-common (= ${source:Version})
+ xnbd-common (= ${binary:Version})
 Description: Network Block Device client with support for live migration
  xNBD is a NBD (Network Block Device) server program, which is fully compatible
  with the NBD client driver of Linux kernel. It adds extended features to the
@@ -50,8 +54,9 @@
 
 
 Package: xnbd-common
-Architecture: all
+Architecture: any
 Depends: ${misc:Depends},
+ ${shlibs:Depends},
  lsb-base (>= 3.2-14),
  python (>= 2.7) | python-argparse,
  module-init-tools,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

VERSION := $(shell dpkg-parsechangelog | perl -ne 'print $$1 if m/Version:\s*([\w\.\-\+\~]+)-\d+/')
REPOSITORY_REV := $(shell echo "$(VERSION)" | perl -ne 'print $$1 if m/hg\d+-(\w+)/')
CFLAGS := $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
export CFLAGS LDFLAGS



%:
	dh $@ --with python2,autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --libdir=/usr/lib/xnbd --disable-silent-rules

override_dh_install:
	rm -f debian/tmp/usr/share/doc/xnbd/xnbd-*.html debian/tmp/usr/share/doc/xnbd/docbook-xsl.css
	# Debian does not want .la files
	rm -f debian/tmp/usr/lib/xnbd/libxnbd_internal.la
	dh_install --list-missing

override_dh_installinit:
	# don't start upon installation/upgrade. We can't ship a feasible
	# default configuration.
	dh_installinit --no-start

override_dh_installchangelogs:
	dh_installchangelogs debian/tmp/usr/share/doc/xnbd/ChangeLog

get-orig-source:
	# Version generated by: hg log -r . --template '{latesttag}-hg{latesttagdistance}-{node|short}\n'
	hg clone https://bitbucket.org/hirofuchi/xnbd xnbd-$(VERSION)-hg
	cd xnbd-$(VERSION)-hg && hg archive -X .hg_archival.txt -X .hgtags -r $(REPOSITORY_REV) -t files ../xnbd-$(VERSION)
	mv -- xnbd-$(VERSION)/trunk/* xnbd-$(VERSION)/
	rmdir xnbd-$(VERSION)/trunk/
	tar jcfv xnbd_$(VERSION).orig.tar.bz2 xnbd-$(VERSION)
	rm -rf xnbd-$(VERSION) xnbd-$(VERSION)-hg

## xnbd 0.3.0

=== debian/changelog ===
xnbd (0.3.0-1ubuntu1) utopic; urgency=medium

  * Build using dh-autoreconf.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 08 Sep 2014 12:19:56 +0200

xnbd (0.3.0-1) unstable; urgency=medium

  * New upstream version
  * Fix "please do not depend on module-init-tools", rather depend on kmod
    now. Thanks to MD for the hint (Closes: #733697)
  * Push standards, no changes needed
  * Remove dh-autoreconf: not needed anymore

 -- Arno Töll <arno@debian.org>  Mon, 17 Feb 2014 00:12:22 -1100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: extra
 Maintainer: Arno Töll <arno@debian.org>
 Build-Depends: debhelper (>= 8.0),
+ dh-autoreconf,
  libglib2.0-dev,
  asciidoc,
  libxml2-utils,
@@ -10,8 +11,7 @@
  docbook-xsl,
  xsltproc,
  python-all-dev (>= 2.6.6-3~),
- dh-autoreconf
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: https://bitbucket.org/hirofuchi/xnbd/wiki/Home
 Vcs-Git: git://anonscm.debian.org/collab-maint/xnbd.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/xnbd.git
@@ -59,7 +59,7 @@
  ${shlibs:Depends},
  lsb-base (>= 3.2-14),
  python (>= 2.7) | python-argparse,
- module-init-tools,
+ kmod,
  ${python:Depends}
 Description: Network Block Device - common files
  xNBD is a NBD (Network Block Device) server program, which is fully compatible

=== debian/rules ===
--- 
+++ 
@@ -22,6 +22,7 @@
 	rm -f debian/tmp/usr/share/doc/xnbd/xnbd-*.html debian/tmp/usr/share/doc/xnbd/docbook-xsl.css
 	# Debian does not want .la files
 	rm -f debian/tmp/usr/lib/xnbd/libxnbd_internal.la
+	# changelog/README and man pages are installed by respective helpers.
 	dh_install --list-missing
 
 override_dh_installinit:

=== debian/watch ===
version=3
opts=dversionmangle=s/\+hg\d{8}$// \
	https://bitbucket.org/hirofuchi/xnbd/downloads/xnbd-(\d+\.\d+.\d+)\.tar\.gz debian uupdate
